#!/usr/bin/perl -w
# -*- Mode: perl; indent-tabs-mode: nil -*-
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.0 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
# 
# The Original Code is the Bugzilla Bug Tracking System.
# 
# The Initial Developer of the Original Code is Netscape Communications
# Corporation. Portions created by Netscape are Copyright (C) 1998
# Netscape Communications Corporation. All Rights Reserved.
# 
# Contributor(s): Terry Weissman <terry@mozilla.org>
#				  David Lawrence <dkl@redhat.com>

require "CGI.pl";

confirm_login();

if (!$::FORM{'submit'}) {
    print "Content-type: text/html\n\n";
	PutHeader("Preferences", "Change your password and<br>other preferences",
              $::COOKIE{'Bugzilla_login'});

    my $qacontactpart = "";
    if (Param('useqacontact')) {
        $qacontactpart = ", the current QA Contact";
    }
    my $loginname = SqlQuote($::COOKIE{'Bugzilla_login'});
    SendSQL("select emailnotification,realname from profiles where login_name = " .
            $loginname);
    my ($emailnotification, $realname) = (FetchSQLData());
    $realname = value_quote($realname);
    print qq{
<FORM METHOD=post>
<HR ALIGN=left WIDTH=800>
<TABLE WIDTH=600>
<TR>
	<TD ALIGN=right>Change your email address (login): </TD>
	<TD ALIGN=left><INPUT TYPE=text SIZE=30 NAME=email VALUE="$::COOKIE{'Bugzilla_login'}"></TD>
</TR><TR>
	<TD ALIGN=right>Please enter the new password for <b>$::COOKIE{'Bugzilla_login'}</b>:</TD>
	<TD><INPUT TYPE=password NAME="pwd1"></TD>
</TR><TR>
	<TD ALIGN=right>Re-enter your new password:</TD>
	<TD><INPUT TYPE=password NAME="pwd2"></TD>
</TR><TR>
	<TD ALIGN=right>Your real name (optional):</TD>
	<TD><INPUT SIZE=35 NAME=realname VALUE="$realname"></TD>
</TR>
</TABLE>

<HR ALIGN=left WIDTH=800>
<TABLE WIDTH=800>
<TR>
	<TD ALIGN=right>Bugzilla will send out email notification of changed bugs to 
	the current owner, the submitter of the bug$qacontactpart, and anyone on the
	CC list.  However, you can suppress some of those email notifications.
	On which of these bugs would you like email notification of changes?</TD>
	<TD><SELECT NAME="emailnotification">
};
    foreach my $i (["ExcludeSelfChanges", "All qualifying bugs except those which I change"],
                   ["CConly", "Only those bugs which I am listed on the CC line"],
                   ["All", "All qualifying bugs"]) {
        my ($tag, $desc) = (@$i);
        my $selectpart = "";
        if ($tag eq $emailnotification) {
            $selectpart = " SELECTED";
        }
        print qq{<OPTION$selectpart VALUE="$tag">$desc\n};
    }
    print qq{
	</SELECT>
	</TD>
</TR>
</TABLE>

<HR ALIGN=left WIDTH=800>
<INPUT TYPE=submit NAME=submit VALUE=Submit>
</FORM>
};

#<HR ALIGN=left WIDTH=800>
# <A HREF="showvotes.cgi">Review your votes</A>
#};
#    navigation_header();

	PutFooter();
    exit;
}

if ($::FORM{'pwd1'} ne $::FORM{'pwd2'}) {
	print "Content-type:text/html\n\n";
    print "<H1>Try again.</H1>
The two passwords you entered did not match.  Please click <b>Back</b> and try again.\n";
    exit;
}


sub x {
    my $sc="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789./";
    return substr($sc, int (rand () * 100000) % (length ($sc) + 1), 1);
}

if (defined($::FORM{'pwd1'})) {
	my $pwd = $::FORM{'pwd1'};

	if ($pwd ne "") {
    	if ($pwd !~ /^[a-zA-Z0-9-_]*$/ || length($pwd) < 3 || length($pwd) > 15) {
			print "Content-type:text/html\n\n";
        	print "
<H1>Sorry; we're picky.</H1>
Please choose a password that is between 3 and 15 characters long, and that
contains only numbers, letters, hyphens, or underlines.
<p>
Please click <b>Back</b> and try again.\n";
        	exit;
    	}
    
		# Generate a random salt.
		# commented out and following added to see if this fixes a rare password changing bug
    	# my $salt  = x() . x();

		my $salt = substr($pwd, 0, 2);
    
    	my $encrypted = crypt($pwd, $salt);
    	SendSQL("update profiles set password = '$pwd', cryptpassword = '$encrypted' where login_name = " .
         	    SqlQuote($::COOKIE{'Bugzilla_login'}));
    	SendSQL("update logincookies set cryptpassword = '$encrypted' where cookie = $::COOKIE{'Bugzilla_logincookie'}");
	}
}

SendSQL("update profiles set emailnotification='$::FORM{'emailnotification'}' where login_name = " .
	 	SqlQuote($::COOKIE{'Bugzilla_login'}));

my $newrealname = $::FORM{'realname'};
	
if ($newrealname ne "") {
	$newrealname = SqlQuote($newrealname);
	SendSQL("update profiles set realname=$newrealname where login_name = " .
			SqlQuote($::COOKIE{'Bugzilla_login'}));
}

my $email_changed = 0;
if ($::FORM{'email'} ne $::COOKIE{'Bugzilla_login'} && !defined($::FORM{'doit'})) {
	# lets see if there is already a account with this email address
	SendSQL("select login_name from profiles where login_name = " . SqlQuote($::FORM{'email'}));
	if (my $result = FetchOneColumn()) {
		print "Content-type:text/html\n\n";
		PutHeader("Invalid Email");
		print "
<H1>Sorry; That email address is currently being used.</H1>
You will need to choose another one or make sure you entered it correctly.
<p>
Please click <A HREF=\"changepassword.cgi\"><b>here</b></A> to go back and start over.\n";
   		exit;
    }

	print "Content-type:text/html\n\n";

	PutHeader("Confirm Email Change");
	print qq{
<B><FONT COLOR=red>Caution:</FONT> You have chose to change your email address from 
$::COOKIE{'Bugzilla_login'}  to  $::FORM{'email'}.<BR>If this entered incorrectly into 
the Bugzilla system, you may not be able to re-login or receive proper email updates.</B>
<P>
Click <B>Go Ahead</B> if this really what you want.
<P>
<FORM METHOD=port>
<INPUT TYPE=hidden NAME=email VALUE="$::FORM{'email'}">
<INPUT TYPE=hidden NAME=doit VALUE=1>
<INPUT TYPE=hidden NAME=submit VALUE=1>
<INPUT TYPE=submit NAME=doit VALUE=" Go Ahead ">
</FORM>
};
	exit;

} elsif ($::FORM{'doit'}) {
	$email_changed = 1;
	CheckEmailSyntax($::FORM{'email'});
	SendSQL("update profiles set login_name = " . SqlQuote($::FORM{'email'}) .
			" where login_name = " . SqlQuote($::COOKIE{'Bugzilla_login'}));
	SendSQL("update components set initialowner = " . SqlQuote($::FORM{'email'}) . 
			" where initialowner = " . SqlQuote($::COOKIE{'Bugzilla_login'}));
	SendSQL("update components set initialqacontact = " . SqlQuote($::FORM{'email'}) .
            " where initialqacontact = " . SqlQuote($::COOKIE{'Bugzilla_login'}));
	delete($::COOKIE{'Bugzilla_login'});
}

if ($email_changed) {
	print "Set-Cookie: Bugzilla_login=; path=/bugzilla/; expires=Sun, 30-Jun-2029 00:00:00 GMT\n";
	print "Set-Cookie: Bugzilla_logincookie=; path=/bugzilla/; expires=Sun, 30-Jun-2029 00:00:00 GMT\n";
	print "Content-type: text/html\n\n";
	PutHeader("Preferences updated.");
	print "
Your preferences have been updated.
<p>
Back to <A HREF=\"query.cgi?GoAheadAndLogIn=1\">Query</A> page.
	";
	exit;
}

print "Content-type: text/html\n\n";

PutHeader("Preferences updated.");
print "
Your preferences have been updated.
<p>
Back to <A HREF=\"query.cgi\">Query</A> page.
";

