#!/usr/bin/perl -w
# -*- Mode: perl; indent-tabs-mode: nil -*-
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.0 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
# 
# The Original Code is the Bugzilla Bug Tracking System.
# 
# The Initial Developer of the Original Code is Netscape Communications
# Corporation. Portions created by Netscape are Copyright (C) 1998
# Netscape Communications Corporation. All Rights Reserved.
# 
# Contributor(s): Sam Ziegler <sam@ziegler.org>
# Terry Weissman <terry@mozilla.org>

# Code derived from editparams.cgi, editowners.cgi

use diagnostics;
use strict;

require "CGI.pl";

# Shut up misguided -w warnings about "used only once":

use vars @::legal_product;

confirm_login();

print "Content-type: text/html\n\n";

if (!UserInGroup("editcomponents")) {
    print "<H1>Sorry, you aren't a member of the 'editcomponents' group.</H1>\n";
    print "And so, you aren't allowed to edit the owners.\n";
    exit;
}


PutHeader("Edit Components");

print "This lets you edit the program components of bugzilla.\n";
print "<HR WIDTH=800 ALIGN=left>";
print "<A HREF=addcomponent.cgi>Add new component.</A><br>\n";
print "<HR WIDTH=800 ALIGN=left>";

my $rowbreak = "<tr><td colspan=2><hr></td></tr>";

unlink "data/versioncache";
GetVersionTable();

if (!$::FORM{'submit'} && !$::FORM{'product'}) {
    print "<FORM METHOD=post ACTION=editcomponents.cgi>\n";
    print "<SELECT NAME=product>\n";
    foreach my $product (@::legal_product) {
        print "<OPTION>$product";
    }
    print "</SELECT>\n";
    print "<INPUT TYPE=submit NAME=submit VALUE=Choose>\n";
    print "</FORM>";

} else {

	my $prodcode = "P000";
	print "<form method=post action=doeditcomponents.cgi>\n";
	foreach my $product ($::FORM{'product'}) {
    	SendSQL("select description, milestoneurl, disallownew, votesperuser 
				 from products where product='$product'");
    	my @row = FetchSQLData();
    	if (!@row) {
        	next;
    	}
    	my ($description, $milestoneurl, $disallownew, $votesperuser) = (@row);
    	$prodcode++;
		print "<INPUT TYPE=hidden NAME=product VALUE = \"" . 
				value_quote($product) . "\">\n";
    	print "<INPUT TYPE=hidden NAME=prodcode-$prodcode VALUE=\"" .
        		value_quote($product) . "\">\n";
		print "<H2>Product: $product</H2>\n";
    	print "<TABLE WIDTH=800>\n";
    	print "<TR><TH ALIGN=right>Description:</TH>\n";
    	print "<TD><INPUT SIZE=70 MAXLENGTH=80 NAME=$prodcode-description VALUE=\"" .
        		value_quote($description) . "\"></td></tr>\n";
    	if (Param('usetargetmilestone')) {
        	print "<TR><TH ALIGN=right>MilestoneURL:</TH>\n";
        	print "<TD><INPUT SIZE=80 NAME=$prodcode-milestoneurl VALUE=\"" .
            		value_quote($milestoneurl) . "\"></td></tr>\n";
    	}
	    print qq{<TR><TH ALIGN=right>Maximum votes per user:</TH><TD>\n};
    	print qq{<INPUT SIZE=10 NAME=$prodcode-votesperuser VALUE=$votesperuser>};
    	print qq{</TD></TR>\n};
    	my $check0 = !$disallownew ? " SELECTED" : "";
    	my $check1 = $disallownew ? " SELECTED" : "";
    	print "<TR><TD></TD><TD ALIGN=left><SELECT NAME=$prodcode-disallownew>\n";
    	print "<OPTION VALUE=0$check0>Open; new bugs may be submitted against this project\n";
    	print "<OPTION VALUE=1$check1>Closed; no new bugs may be submitted against this project\n";
    	print "</SELECT></TD></TR>\n";
		print "</TABLE>\n<HR WIDTH=800 ALIGN=left>\n";

    	print "<H2>$product components: </H2>\n";
    
    	SendSQL("select value, initialowner, initialqacontact, description 
				 from components where program=" . SqlQuote($product) . " order by value");
    	my $c = 0;
    	while (my @row = FetchSQLData()) {
        	my ($component, $initialowner, $initialqacontact, $description) = (@row);
            $c++;
        	my $compcode = $prodcode . "-" . "C$c";
			print "<U><B>$component\n</B></U>";
        	print "<TABLE>\n";
			print "<INPUT TYPE=hidden NAME=compcode-$compcode VALUE=\"" .
            		value_quote($component) . "\">\n";
        	print "<TR><TH ALIGN=right>Description:</TH>\n";
        	print "<TD><INPUT SIZE=70 MAXLENGTH=80 NAME=$compcode-description VALUE=\"" .
        			value_quote($description) . "\"></td></tr>\n";
        	print "<TR><TH ALIGN=right>Initial owner:</TH>\n";
        	print "<TD><INPUT SIZE=60 NAME=$compcode-initialowner VALUE=\"" .
        			value_quote($initialowner) . "\"></TD></TR>\n";
        	if (Param('useqacontact')) {
            	print "<TR><TH ALIGN=right>Initial QA contact:</TH>\n";
            	print "<td><input size=60 name=$compcode-initialqacontact value=\"" .
               			 value_quote($initialqacontact) . "\"></td></tr>\n";
        	}
			print "</TABLE>\n<HR WIDTH=800 ALIGN=left>\n";
    	}
		print "<INPUT TYPE=submit VALUE=\"Submit changes\">\n";
		print "</FORM>";
	}
}

PutFooter();

