#!/usr/bin/perl -w
# -*- Mode: perl; indent-tabs-mode: nil -*-
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.0 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
# 
# The Original Code is the Bugzilla Bug Tracking System.
# 
# The Initial Developer of the Original Code is Netscape Communications
# Corporation. Portions created by Netscape are Copyright (C) 1998
# Netscape Communications Corporation. All Rights Reserved.
# 
# Contributor(s): Terry Weissman <terry@mozilla.org>
#				  David Lawrence <dkl@redhat.com>

use diagnostics;
use strict;

require "CGI.pl";
require "globals.pl";

confirm_login();

print "Content-type: text/html\n\n";

if (!UserInGroup("editcomponents")) {
    print "<H1>Sorry, you aren't a member of the 'editcomponents' group.</H1>\n";
    print "And so, you aren't allowed to edit the members.\n";
    exit;
}

PutHeader("Edit Members");

if ($::FORM{'submit'}) {
	print qq{ <H2>Results for search on };
	if ($::FORM{'login_name'}) {
		print "$::FORM{'login_name'} ";
	}
	if ($::FORM{'login_name'} && $::FORM{'realname'}) {
		print " and ";
	}
	if ($::FORM{'realname'}) {
		print "$::FORM{'realname'} ";
	}
	print qq{ 
</H2>
<P>
};

	# Form the query
	if (!$::FORM{'login_name'} && !$::FORM{'realname'}) {
        print "<P>Illegal values - Back up and try again.";
		exit;
    }
	my $query = "select userid, login_name, realname
				 from profiles where"; 
	if ($::FORM{'login_name'}) {
		$query .= " login_name like \'%$::FORM{'login_name'}%\'";
	}
	if ($::FORM{'login_name'} && $::FORM{'realname'}) {
		$query .= " or ";
	}
	if ($::FORM{'realname'}) {
		$query .= " realname like \'%$::FORM{'realname'}%\'";
	}
	$query .= " order by userid";
	SendSQL($query);
	my @row = ();

	# Print the results
	print qq{
<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=4>
<TR BGCOLOR="#BFBFBF">
	<TD ALIGN=left><B>User ID</B></TD>
	<TD ALIGN=left><B>Email Address<B></TD>
	<TD ALIGN=left><B>Real Name</B></TD>
</TR>
};
	my $count = 0;
	while (@row = FetchSQLData()) {
		print qq{
<TR BGCOLOR="#ECECEC">
	<TD ALIGN=center><A HREF="editmembers.cgi?\&userid=$row[0]">$row[0]</A>&nbsp;</TD>
	<TD ALIGN=left>$row[1]</TD>
};
		# For some reason netscape was choking when this value was NULL
		if (!$row[2]) {
			$row[2] = "&nbsp;";
		}
		print qq{    
	<TD ALIGN=left>$row[2]</TD>
</TR>
};

	}	
	print qq{
</TABLE>	
<P>
<A HREF="editmembers.cgi">Edit another member</A>
};

} elsif ($::FORM{'userid'}) {
	if ($::FORM{'update'}) {
		if ($::FORM{'password'}) {
			if ($::FORM{'password'} ne $::FORM{'retype'}) {
				print qq{
<FONT SIZE=+1 COLOR=red>Sorry.</FONT><B>The passwords you entered were not the same.
Please click BACK and correct the error.</B>
};				
				exit;
			}
			my $password = $::FORM{'password'};
			my $encrypted = crypt($password, substr($password, 0, 2));
			SendSQL("update profiles set password = " . SqlQuote($password) .
					", cryptpassword = " . SqlQuote($encrypted) . 
					" where login_name = " . SqlQuote($::FORM{'login_name'}));
			MailPassword($::FORM{'login_name'}, $password, 1);	
			print "Password changed and member notified.<BR>\n";
		}

		SendSQL("update profiles set login_name = " . SqlQuote($::FORM{'login_name'}) .
				" where userid = " . $::FORM{'userid'});
		print "Login name updated.<BR>\n";

		SendSQL("update profiles set realname = " . SqlQuote($::FORM{'realname'}) .
                " where userid = " . $::FORM{'userid'});
		print "Real name updated.<BR>\n";

		SendSQL("delete from user_group where userid = " . $::FORM{'userid'});
		foreach my $i (grep (/^group-.*$/, keys %::FORM)) {
			$i =~ s/^group-//g;
			SendSQL("insert into user_group values (" . 
					$::FORM{'userid'} . ", $i)");
		}
		print "Group membership updated.<P>\n";
	}
	
	SendSQL("select login_name, realname from profiles where userid = " . $::FORM{'userid'});
	my @user_info = FetchSQLData();	

	SendSQL("select groupid, description from groups order by groupid");
	my %grouplist;
	my @row;
	while (@row = FetchSQLData()) {
		$grouplist{$row[0]} = $row[1];
	}

	SendSQL("select groupid from user_group where userid = " . $::FORM{'userid'});
	my @groupbelong;
	while (@row = FetchSQLData()) {
		push (@groupbelong, $row[0]);
	}
	
	print qq{
<H1>Information for <FONT COLOR=blue>$user_info[0]</FONT></H1>
<P>	
<FORM NAME=changeform METHOD=post ACTION=editmembers.cgi>
<TABLE>
<TR>
	<TD ALIGN=right><B>User ID#: </B></TD>
	<TD ALIGN=left><B><FONT COLOR=blue>$::FORM{'userid'}</FONT></B></TD>
</TR><TR>
	<TD ALIGN=right><B>Email Address: </B></TD>
	<TD ALIGN=left><INPUT TYPE=text SIZE=40 MAXLENGTH=60 NAME=login_name VALUE="$user_info[0]"></TD>
</TR><TR>
	<TD ALIGN=right><B>Real Name: </B></TD>
	<TD ALIGN=left><INPUT TYPE=text SIZE=40 MAXLENGTH=60 NAME=realname VALUE="$user_info[1]"></TD>
</TR><TR>
	<TD ALIGN=right><B>New Password (8 chars.): </B></TD>
	<TD ALIGN=left><INPUT TYPE=password NAME=password></TD>
</TR><TR>
	<TD ALIGN=right><B>Retype New Password (8 chars.): </TD>
	<TD ALIGN=left><INPUT TYPE=password NAME=retype></TD>
</TR>
</TABLE>
<B><FONT SIZE=+1 COLOR=red>Note:</FONT> If the current password is changed, it will be automatically
mailed out to the member.</B>
<P>
<HR ALIGN=left WIDTH=800>	
<H2>Check which groups you wish this member to be in.</H2>
<P>
<INPUT TYPE=HIDDEN NAME=userid VALUE="$::FORM{'userid'}">
};	
	my $count = 0;
	foreach my $i (keys %grouplist) {
    	my $c;
    	if (lsearch(\@groupbelong, $i) >= 0) {
        	$c = 'CHECKED';
    	} else {
        	$c = '';
    	}
    	print qq{
<INPUT TYPE=checkbox NAME=group-$i $c> $grouplist{$i}<br>
};
	}

    print "
<P>
<SCRIPT>
numelements = document.changeform.elements.length;
function SetCheckboxes(value) {
    for (var i=0 ; i<numelements ; i++) {
        item = document.changeform.elements\[i\];
        item.checked = value;
    }
}
document.write(\" <input type=button value=\\\"Uncheck All\\\" onclick=\\\"SetCheckboxes(false);\\\"> <input type=button value=\\\"Check All\\\" onclick=\\\"SetCheckboxes(true);\\\">\");
</SCRIPT>\n";

	print qq{
<P>
<HR ALIGN=left WIDTH=800>
<INPUT TYPE=submit NAME=update VALUE=" Update! ">
</FORM>
<A HREF="editmembers.cgi">[Edit another member]</A>
};

} else {
	print qq{
<FORM <METHOD=post ACTION=editmembers.cgi>
<TABLE>
<TR>
	<TD COLSPAN=2><U><B>Enter email address or partial real name of member you want to edit</B></U></TD>
</TR><TR>
	<TD ALIGN=right><B>Email Address: </B></TD>
	<TD ALIGN=left><INPUT TYPE=text SIZE=30 MAXLENGTH=40 NAME=login_name></TD>
</TR><TR>
	<TD ALIGN=right><B>Full Name: </B></TD>
	<TD ALIGN=left><INPUT TYPE=text SIZE=30 MAXLENGTH=40 NAME=realname></TD>
</TR><TR>
	<TD COLSPAN=2 ALIGN=center><INPUT TYPE=submit NAME=submit VALUE=Find></TD>
</TR>
</TABLE>
</FORM>
};

}

PutFooter();

