#!/usr/bin/perl -w
#
#     The contents of this file are subject to the Mozilla Public License
#     Version 1.0 (the "License"); you may not use this file except in
#     compliance with the License. You may obtain a copy of the License at
#     http://www.mozilla.org/MPL/
#
#     Software distributed under the License is distributed on an "AS IS"
#     basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
#     License for the specific language governing rights and limitations
#     under the License.
#
#     The Original Code is the Bugzilla Bug Tracking System.
#
#     The Initial Developer of the Original Code is Netscape Communications
#     Corporation. Portions created by Netscape are Copyright (C) 1998
#     Netscape Communications Corporation. All Rights Reserved.
#
#     Contributor(s): Terry Weissman <terry@mozilla.org>
#					  David Lawrence <dkl@redhat.com>

use diagnostics;
use strict;

require 'CGI.pl';

print "Content-type:text/html\n\n";

PutHeader("Clue Page");

print "
<TABLE WIDTH=800>
<TR>
	<TD>
<H1>A Clue</H1>

This form will allow you to call up a subset of the bug list.
You should be able to add the URL of the resulting list to
your bookmark file in order to preserve queries.
<P>
The way the query works, if you have nothing checked in a box,
then all values for that field are legal, for example if you checked nothing
in any of the boxes, you would get the entire bug list.
<P>
The default value of this form should correspond roughly to a <I>personal</I>
bug list.

<HR>

<H2>Running queries not supported by the pretty boxes</H2>

There is a hacky way to do some searches that aren't supported by the
form.  The buglist script will build queries based on the URL, so
you can add other criteria.
<P>
For example, if you wanted to see all bugs reported against the X platform
and assigned to jwz, you could ask for all bugs assign to jwz, then
edit the URL in the \"Location\" box, adding the clause \"&rep_platform=X-Windows\"
to the URL.
<P>
Here is a list of some of the field names you could use for additional
unsupported searches ...

<PRE>
version
rep_platform
op_sys
bug_file_loc
short_desc
</PRE>
	</TD>
</TR>
</TABLE>
";

PutFooter();
